[lax.l 02aug91]

(off $fd $buf)
(zero $cnt)

<de la2Cmd (w)
   (catch 'error
      (local (lst)
         (when
            (setq lst
               (dialog #(str "Save LA2")
                  '(#(str "Filename"))
                  (cons (get *job 'name)) ) )
            (mkLa2)
            (unless
               (zerop
                  (system
                     (append
                        "doscp "
                        *home
                        "tmp/la2.tmp "
                        "A:/LAYOUT/"
                        (car lst)
                        ".LA2" ) ) )
               (cosyError #(str "Save LA2 Fehler")) >

<de mkLa2 ()
   (local (l)
      (unless (setq $buf (alloc 1024))
         (cosyError #(str "Memory Allocation Fehler")) )
      (setq $fd (doCreate (append *home "tmp/la2.tmp")))
      (zero $cnt)
      [++ Head ++]
      (la-version "001.00") [Six chars]
      (la-int 0) [Anzahl Gruppen]
      (setq l (get *job 'strokes))
      (la-rect [Layout Size ohne Bemassung]
         (total
            (filter l
               (lambda (s)
                  (neq (cadr *stat) (get s 'status)) ) ) ) )
      (la-rect [Layout Size mit Bemassung]
         (total l) )
      (la-int 0) [Max. Gruppen-Schachtelung]
      (la-int (zero $cnt)) [Anzahl Elemente Top-Level]
      [++ Data ++]
      (dupInit)
      (all la2 l)
      [++ Done ++]
      (seek 75 $fd) [Patch # of TopLevel Elements]
      (la-int $cnt)
      (free $buf)
      (close $fd) >

<de la-version (s)
   (stuff $buf s (01A)) [Version: 6+1 chars]
   (writeBlock $fd $buf 7) >

<de la-stat (s)
   (stuff $buf
      (append
         (car s)
         (nthcdr (length (car s)) "..........") ) )
   (word (add 10 $buf) 0)
   (writeBlock $fd $buf 12) >

<de la-int (n)
   (word $buf n)
   (writeBlock $fd $buf 2) >

<de la-double (s n)
   (double s $buf n)
   (writeBlock $fd $buf 8) >

<de la-point (h v)
   (double 10000 $buf h)
   (double 10000 (add 8 $buf) v)
   (writeBlock $fd $buf 16) >

<de la-line (pt1 pt2)
   (la-point (car pt1) (cdr pt1))
   (la-point (car pt2) (cdr pt2)) >

<de la-rect (r)
   (la-point (left r) (top r))
   (la-point (right r) (bottom r)) >

<de la-mat (a b c d e f)
   (double 10000 $buf a)
   (double 10000 (add 8 $buf) d)
   (double 10000 (add 16 $buf) b)
   (double 10000 (add 24 $buf) e)
   (double 10000 (add 32 $buf) c)
   (double 10000 (add 40 $buf) f)
   (writeBlock $fd $buf 48) >

[+++ Stroke LA2 Methods +++]
<to la2 stroke (obj)
   (local (x)
      (with obj
         (draw 1000 (dupChk (slot graf))
            (lambda (h1 v1 h2 v2)
               (la2line h1 v1 h2 v2) )
            (lambda (p q r s)
               (when (setq x (circBez p q r s))
                  (la2arc p (cdr x) s (car x))
                  t >

(to la2 s-set (obj))

<de la2line (h1 v1 h2 v2)
   (unless
      (and
         (equal h1 h2)
         (equal v1 v2) )
      (la-int 8) [Type LINE]
      (inc $cnt)
      (la-stat (slot status))
      (la-point h1 v1)
      (la-point h2 v2) >

<to la2 s-point (obj)
   (with obj
      (la-int 32) [Type POINT]
      (inc $cnt)
      (la-stat (slot status))
      (la-point (car (slot pt)) (cdr (slot pt))) >

(setq $M2PI 3600000)

<de la2arc (pa m pe flg)
   (local (cw sw wd r aw ew)
      (setq
         r (distpt pa m)
         aw (winkl m pa)
         ew (winkl m pe)
         wd (lgrad aw)
         cw (cos wd 10000)
         sw (sin wd 10000)
         wd (if flg
            (if (lessp aw ew) (sub ew aw) (sub ew aw (minus $M2PI)))
            (if (lessp ew aw) (sub ew aw) (sub ew aw $M2PI)) ) )
      (la-int 1) [Type ARC]
      (inc $cnt)
      (la-stat (slot status))
      (la-mat
         (muldiv r cw 10000)
         (mul (if flg 1 -1) (muldiv r sw 10000))
         (car m)
         (muldiv r sw 10000)
         (mul (if flg -1 1) (muldiv r cw 10000))
         (cdr m) )
      (la-double 10000000
         (muldiv (abs wd) 314159265 18000000) >

<to la2 s-circle (obj)
   (with obj
      (la2arc
         (caar (slot graf))
         (slot pt)
         (last (last (slot graf)))
         (rSyst
            (slot pt)
            (caar (slot graf))
            (car (cadar (slot graf))) >

<to la2 s-grp (obj)
   (all la2 (get obj 'strokes)) >

[+++
<de la1Cmd (w)
   (fileDialog "LA1" mkLa1) >
+++]

<de la1Cmd (w)
   (catch 'error
      (local (lst)
         (when
            (setq lst
               (dialog #(str "Save LA1")
                  '(#(str "Filename"))
                  (cons (get *job 'name)) ) )
            (mkLa1)
            (unless
               (zerop
                  (system
                     (append
                        "doscp "
                        (append *home "tmp/la1.tmp A:/LAYOUT/")
                        (car lst)
                        ".LA1" ) ) )
               (cosyError #(str "Save LA1 Fehler")) >

<de mkLa1 ()
   (local (l)
      (unless (setq $buf (alloc 1024))
         (cosyError #(str "Memory Allocation Fehler")) )
      (setq $fd (doCreate (append *home "tmp/la1.tmp")))
      (zero $cnt)
      [++ Head ++]
      (la-int 0) [Anzahl Gruppen]
      (setq l (get *job 'strokes))
      (la-rect [Layout Size ohne Bemassung]
         (total
            (filter l
               (lambda (s)
                  (neq (cadr *stat) (get s 'status)) ) ) ) )
      (la-rect [Layout Size mit Bemassung]
         (total l) )
      [+++++  16 byte  toplevel element  +++++]
      (la-point 0 0)
      [++ Data ++]
      (dupInit)
      (all la1 l)
      [++ Done ++]
      (seek 78 $fd) [Patch # of TopLevel Elements]
      (la-int $cnt)
      (free $buf)
      (close $fd) >

[+++ Stroke la1 Methods +++]
<to la1 stroke (obj)
   (local (x)
      (with obj
         (draw 1000 (dupChk (slot graf))
            (lambda (h1 v1 h2 v2)
               (la-int 46) [length LINE-element]
               (la-int 0) [Type LINE]
               (inc $cnt)
               (la-point h1 v1)
               (la-point h2 v2)
               (la-stat (slot status)) )
            (lambda (p q r s)
               (when (setq x (circBez p q r s))
                  (la1arc p (cdr x) s (car x) (slot status))
                  t >

(to la1 s-set (obj))

<to la1 s-point (obj)
   (with obj
      (la-int 46) [length LINE-element]
      (la-int 0) [Type LINE]
      (inc $cnt)
      (la-point (car (slot pt)) (cdr (slot pt)))
      (la-point (add 10 (car (slot pt))) (cdr (slot pt)))
      (la-stat (slot status)) >

<de la1arc (pa m pe flg st)
   (local (aw ew d)
      (setq d (distPt m pa) )
      [+++++++
      (setq
         aw
         (la-double
            10000000
            (muldiv
               (lgrad (winkl m pa))
               314159265 18000000 ) )
         ew
         (la-double
            10000000
            (muldiv
               (lgrad (winkl m pe))
               314159265 18000000 ) ) )
      +++++]
      (if (equal pa pe)
         (progn
            (la-int 46) [length circle-element]
            (la-int 2) )  [Type CIRCLE]
         (progn
            (la-int 54) [length ARC-element]
            (la-int 1) ) )  [Type ARC]
      (inc $cnt)
      (la-point (car m) (cdr m))
      (la-double 10000 (if flg (minus d) d))
      (la-double
         10000000
         (muldiv
            (lgrad (winkl m pa))
            314159265 18000000 ) )
      (unless (equal pa pe)
         (la-double
            10000000
            (muldiv
               (lgrad (winkl m pe))
               314159265 18000000 ) ) )
      (la-stat st) >

<to la1 s-circle (obj)
   (with obj
      (la1arc
         (caar (slot graf))
         (slot pt)
         (last (last (slot graf)))
         (rSyst
            (slot pt)
            (caar (slot graf))
            (car (cadar (slot graf))) )
         (slot status) >

<to la1 s-grp (obj)
   (all la1 (get obj 'strokes)) >

t
[lax.l 08may91]

(off $fd $buf)
(zero $cnt)

<de la2Cmd (w)
   (fileDialog "LA2" mkLa2) >

<de mkLa2 (nm)
   (local (l)
      (unless (setq $buf (alloc 1024))
         (cosyError #(str "Memory Allocation Fehler")) )
      (setq $fd (doCreate nm))
      (zero $cnt)
      [++ Head ++]
      (la-version "001.00") [Six chars]
      (la-int 0) [# Gruppen]
      (setq l (get *job 'strokes))
      (la-rect [Layout Size ohne Bemassung]
         (total
            (filter l
               (lambda (s)
                  (neq (cadr *stat) (get s 'status)) ) ) ) )
      (la-rect [Layout Size mit Bemassung]
         (total l) )
      (la-int 0) [Max. Gruppen-Schachtelung]
      (la-int (zero $cnt)) [# Elemente Top-Level]
      [++ Data ++]
      (dupInit)
      (all la2 l)
      [++ Done ++]
      (seek 75 $fd) [Patch # of TopLevel Elements]
      (la-int $cnt)
      (free $buf)
      (close $fd) >

<de la-version (s)
   (stuff $buf s (01A)) [Version: 6+1 chars]
   (writeBlock $fd $buf 7) >

<de la-stat (s)
   (stuff $buf
      (append
         (car s)
         (nthcdr (length (car s)) "..........") ) )
   (word (add 10 $buf) 0)
   (writeBlock $fd $buf 12) >

<de la-int (n)
   (word $buf n)
   (writeBlock $fd $buf 2) >

<de la-double (s n)
   (double s $buf n)
   (writeBlock $fd $buf 8) >

<de la-point (pt)
   (double 10000 $buf (car pt))
   (double 10000 (add 8 $buf) (cdr pt))
   (writeBlock $fd $buf 16) >

<de la-line (pt1 pt2)
   (la-point pt1)
   (la-point pt2) >

<de la-rect (r)
   (la-double 10000 (left r))
   (la-double 10000 (top r))
   (la-double 10000 (right r))
   (la-double 10000 (bottom r)) >

<de la-mat (a b c d e f)
   (double 10000 $buf a)
   (double 10000 (add 8 $buf) d)
   (double 10000 (add 16 $buf) b)
   (double 10000 (add 24 $buf) e)
   (double 10000 (add 32 $buf) c)
   (double 10000 (add 40 $buf) f)
   (writeBlock $fd $buf 48) >

[+++ Stroke LA2 Methods +++]
<to la2 stroke (obj)
   (local (x)
      (with obj
         (draw 1000 (dupChk (slot graf))
            (lambda (h1 v1 h2 v2)
               (la-int 8) [Type LINE]
               (inc $cnt)
               (la-stat (slot status))
               (la-point h1 v1)
               (la-point h2 v2) )
            (lambda (p q r s)
               (when (setq x (circBez p q r s))
                  (la2arc p (cdr x) s (car x))
                  t >

(to la2 s-set (obj))

<to la2 s-point (obj)
   (with obj
      (la-int 32) [Type POINT]
      (inc $cnt)
      (la-stat (slot status))
      (la-point (car (slot pt)) (cdr (slot pt))) >

<de la2arc (pa m pe flg)
   (la-int 1) [Type ARC]
   (inc $cnt)
   (la-stat (slot status))
      (la-point (car pa) (cdr pa))
      (la-point (car pe) (cdr pe))
      (la-point (car  m))
   (la-double 10000 (cdr m))
   (when flg (xchg pa pe) )
   (la-double 10000000
      (muldiv
         (wDiff (winkl m pe) (winkl m pa))
         314159265 18000000 >

[++++++++++++++++++
<de la2arc (pa m pe flg)
   (local (a b c d e f w ca sa)
      (la-int 1) [Type ARC]
      (inc $cnt)
      (la-stat (slot status))
      [+ Scale with Radius +]
      (setq a (setq e (distPt m pa)))
      (zero b c d f)
      [+ Rotation +]
      (setq
         w (lgrad (winkl m pa))
         ca (cos w 10000)
         sa (sin w 10000) )
      (matMul a b c d e f
         ca sa 0 (minus sa) ca 0 )
      [+ Translation +]
      (matMul a b c d e f
         10000 0 (car m) 0 10000 (cdr m) )
      (la-mat a b c d e f)
      (la-double 10000000
         (muldiv
            (if flg
               (minus (wDiff (winkl m pa) (winkl m pe)))
               (wDiff (winkl m pe) (winkl m pa)) )
            314159265 18000000 >
+++++++++++++++]

<to la2 s-circle (obj)
   (with obj
      (la2arc
         (caar (slot graf))
         (slot pt)
         (last (last (slot graf)))
         (rSyst
            (slot pt)
            (caar (slot graf))
            (car (cadar (slot graf))) >

<to la2 s-grp (obj)
   (all la2 (get obj 'strokes)) >

<de la1Cmd (w)
   (fileDialog "LA1" mkLa1) >

<de mkLa1 (nm)
   (local (l)
      (unless (setq $buf (alloc 1024))
         (cosyError #(str "Memory Allocation Fehler")) )
      (setq $fd (doCreate nm))
      (zero $cnt)
      [++ Head ++]
      (la-int 0) [# Gruppen]
      (setq l (get *job 'strokes))
      (la-rect [Layout Size ohne Bemassung]
         (total
            (filter l
               (lambda (s)
                  (neq (cadr *stat) (get s 'status)) ) ) ) )
      (la-rect [Layout Size mit Bemassung]
         (total l) )
      [+++++  16 byte  toplevel element  +++++]
      (la-point 0 0)
      [++ Data ++]
      (dupInit)
      (all la1 l)
      [++ Done ++]
      (seek 78 $fd) [Patch # of TopLevel Elements]
      (la-int $cnt)
      (free $buf)
      (close $fd) >

[+++ Stroke la1 Methods +++]
<to la1 stroke (obj)
   (local (x)
      (with obj
         (draw 1000 (dupChk (slot graf))
            (lambda (h1 v1 h2 v2)
               (la-int 46) [length LINE-element]
               (la-int 0) [Type LINE]
               (inc $cnt)
               (la-point h1 v1)
               (la-point h2 v2)
               (la-stat (slot status)) )
            (lambda (p q r s)
               (when (setq x (circBez p q r s))
                  (la1arc p (cdr x) s (car x) (slot status))
                  t >

(to la1 s-set (obj))

<to la1 s-point (obj)
   (with obj
      (la-int 46) [length LINE-element]
      (la-int 0) [Type LINE]
      (inc $cnt)
      (la-point (car (slot pt)) (cdr (slot pt)))
      (la-point (car (slot pt)) (cdr (slot pt)))
      (la-stat (slot status)) >

<de la1arc (pa m pe flg st)
   (local (d)
      (setq d (distPt m pa))
      (la-int 54) [length ARC-element]
      (la-int 1) [Type ARC]
      (inc $cnt)
      (la-point (car m) (cdr m))
      (la-double 10000 (if flg (minus d) d))
      (la-double
         10000000
         (muldiv
            (lgrad (winkl m pa))
            314159265 18000000 ) )
      (la-double
         10000000
         (muldiv
            (lgrad (winkl m pe))
            314159265 18000000 ) )
      [+++++++++
      (la-double 10000 (lgrad (winkl m pe)))
      +++++++++++]
      (la-stat st) >

<to la1 s-circle (obj)
   (with obj
      (la1arc
         (caar (slot graf))
         (slot pt)
         (last (last (slot graf)))
         (rSyst
            (slot pt)
            (caar (slot graf))
            (car (cadar (slot graf))) )
         (slot status) >

<to la1 s-grp (obj)
   (all la1 (get obj 'strokes)) >

t
